// code by jph

class aniLink3 : public aniLink { // spherical joint
public:  
  aniLink3(aniMated* ani0,tensor<double> lev0,
           aniMated* ani1,tensor<double> lev1,
           tensor<double> dir,double rev,
           double fmu);  
  void draw(void);
  char* toString(void) { return "aniLink3"; };
};

aniLink3::aniLink3(aniMated* ani0,tensor<double> lev0,
         aniMated* ani1,tensor<double> lev1,
         tensor<double> dir,double rev,
         double fmu) : aniLink(ani0,lev0,ani1,lev1,dir,rev,fmu) {
  rank=3;
  isConsistent();
}

void aniLink3::draw(void) {
  double bse,hgt;
  double rad=min(gl3v(lev[0]).norm(),gl3v(lev[1]).norm());
  for (int c0=0;c0<2;++c0) {
    glPushMatrix();
      glMultMatrixd(ani[c0]->pos.data);
      glMultMatrixd(trf[c0].data);
      glColor4dv(ani[c0]->col.data);
      //bse=ani[c0]->ext.x(lev[c0]).norm(2)*0.1;
      bse=lev[c0].norm()*0.08;
      hgt=gl3v(lev[c0]).norm();
      glutSolidCone(0.05+bse,hgt,5+bse*50,5+hgt*5);
      //glutSolidCylinder(0,hgt,0.05+bse,rad*0.03,20);
      glTranslated(0,0,gl3v(lev[c0]).norm());
      glutSolidSpherebw(0,MATH_PI*(0.6+0.4*c0),rad*(0.20-c0*0.03),32,4,ani[c0]->col);
    glPopMatrix();
  }
}
