// code by jph

#ifndef AUDIO_INCLUDED
#define AUDIO_INCLUDED

#include "../_extern/fmod.h"

class audio {
public:
  audio(void) {
    channel=0;
  }
  
  ~audio() {
    //if (channel) {
    //  FMOD_Channel_Stop(channel); // TODO, what if not initialized!?!?!?!
    //  printf("STOPPED \n");
    //}
  }
  
  audio(char* str,uint mode) { // FMOD_LOOP_NORMAL | FMOD_3D    
    tensor<char> key=tensor<char>::string(str);
    if (!hash.get(key,sound))
      FMOD_System_CreateSound(system,str,mode,0,&sound);
    FMOD_System_PlaySound(system,FMOD_CHANNEL_FREE,sound,1,&channel);    
    pos=tensor<double>::eye(4);
    vel=tensor<double>::vector(4);
    vol=1.0;
    if (mode&FMOD_LOOP_NORMAL) {
      uint len;
      FMOD_Sound_GetLength(sound,&len,FMOD_TIMEUNIT_MS);
      FMOD_Channel_SetPosition(channel,random<int>::uniform(len),FMOD_TIMEUNIT_MS);
    }
  }
  
  void play(void) {
    FMOD_VECTOR pnt,vlc;
    setVector(&pnt,pos[3]);
    setVector(&vlc,vel);    
    FMOD_Channel_Set3DAttributes(channel,&pnt,&vlc);
    FMOD_Channel_SetVolume(channel,vol);
    FMOD_Channel_SetPaused(channel,0);
  }
  
  tensor<double> pos;
  tensor<double> vel;
  double vol;
  FMOD_CHANNEL* channel;
  FMOD_SOUND* sound; // maybe not needed!
  
// -----------------------------------------------------------------  
  static FMOD_SYSTEM* system;
  static hash<tensor<char>,FMOD_SOUND*> hash;
  
  static void main(void) {
    FMOD_System_Create(&system);
    FMOD_System_Init(system,1024,FMOD_INIT_3D_RIGHTHANDED|FMOD_INIT_VOL0_BECOMES_VIRTUAL,0);    
  }
  
  static void setVector(FMOD_VECTOR* myVector,tensor<double> myTensor) {
    myVector->x=myTensor.data[0];
    myVector->y=myTensor.data[1];
    myVector->z=myTensor.data[2];
  }
  
  static void listen(tensor<double>& pos,tensor<double>& vel) {
    FMOD_VECTOR pnt,fwd,upw,vlc;
    setVector(&upw,pos[1]);
    setVector(&fwd,pos[2]);
    setVector(&pnt,pos[3]);
    setVector(&vlc,vel);
    FMOD_System_Set3DListenerAttributes(system,0,&pnt,&vlc,&fwd,&upw);     // update 'ears'
    FMOD_System_Update(system);
  }
  
};

FMOD_SYSTEM* audio::system=0;
hash<tensor<char>,FMOD_SOUND*> audio::hash(128);

#endif
