// code by jph

#ifndef COMPLEX_INCLUDED
#define COMPLEX_INCLUDED

static char COMPLEX_BUFFER[128];

template<class type>
class complex {
  public:
    complex<type>(void);
    complex<type>(const type& r); 
    complex<type>(const type& r,const type& i);
    complex<type>(const complex<type>& myComplex);
    const complex<type>& operator=(const complex<type>& myComplex);
    complex<type> operator+(const complex<type>& myComplex);
    complex<type> operator-(const complex<type>& myComplex);
    complex<type> operator*(const complex<type>& myComplex);
    complex<type> operator/(const complex<type>& myComplex); 
    char* toInfo(void); // developed    
//----------------------------------------------------------------------
    type re;
    type im;
};

template<class type>
complex<type>::complex(void) {
  re=0;
  im=0;
}

template<class type>
complex<type>::complex(const type& r,const type& i) {
  re=r;
  im=i;
}

template<class type>
complex<type>::complex(const type& r) {
  re=r;
  im=0;
}

template<class type>
complex<type>::complex(const complex<type>& copy) {
  re=copy.re;
  im=copy.im;
}

template<class type>
const complex<type>& complex<type>::operator=(const complex<type>& myComplex) {
  re=myComplex.re;
  im=myComplex.im;
  return *this;
}

template<class type>
complex<type> complex<type>::operator+(const complex<type>& myComplex) {
  return complex<type>(re+myComplex.re,im+myComplex.im);
}

template<class type>
complex<type> complex<type>::operator-(const complex<type>& myComplex) {
  return complex<type>(re-myComplex.re,im-myComplex.im);
}

template<class type>
complex<type> complex<type>::operator*(const complex<type>& myComplex) {
  return complex<type>(re*myComplex.re-im*myComplex.im,re*myComplex.im+im*myComplex.re);
}

template<class type>
complex<type> complex<type>::operator/(const complex<type>& myComplex) {
  type fac=1/(myComplex.re*myComplex.re+myComplex.im*myComplex.im);
  return complex<type>((re*myComplex.re+im*myComplex.im)*fac,(im*myComplex.re-re*myComplex.im)*fac);
}

template<class type>
char* complex<type>::toInfo() {  
  sprintf(COMPLEX_BUFFER,"complex<%i>(%10.2e,%10.2e)",sizeof(type),re,im);
  return COMPLEX_BUFFER;
}

#endif
