// code by jph

#ifndef HASH_INCLUDED
#define HASH_INCLUDED

#define HASH_NEW_EMPTY                  SET_RESIZE \
                                    table=tensor<linked<bucket<type,cont>>*>(1,&size); \
                                    for (int c1=0;c1<table.numel;c1++) \
                                      table(c1)=new linked<bucket<type,cont>>(); \
                                    numel=0;

#define HASH_APPLY(cmd)             uint adr=func(key)%table.numel; \
                                    bucket<type,cont> buck; \
                                    while (table(adr)->token(buck)) \
                                      if (buck.key==key) { \
                                        cmd \
                                        table(adr)->reset(); \
                                        return 1; \
                                      }
                                    
static char HASH_BUFFER[1024];

template<class type,class cont>
class bucket {
public:
  type key;  // =, ==
  cont data; // =
};

template<class type,class cont>
class hash {
public:
  hash<type,cont>(void);
  hash<type,cont>(int size);
  hash<type,cont>(int size,uint (*func)(type));    //init with # of buckets and hash function (ptr)
  ~hash<type,cont>(void);
  // const hash<type,cont>& operator=(const hash<type,cont>& myHash); does not make sense unless we have equal for linked
  int    get(const type& key,cont &data); // used
  int    add(const type& key,const cont& data); // used, existing content has precedence!!!
  int toggle(const type& key,const cont& data); // used
  int remove(const type& key);
  void empty(void);
  tensor<cont> toTensor(void);
  cont toTensor(int num); // use only when cont is tensor
  double variance(void);
  char* toInfo(void);
  char* toString(void); 
//----------------------------------------------------------------------
  tensor<linked<bucket<type,cont>>*> table;
  int numel;  
private:
  uint (*func)(type);
};

template<class type,class cont>
hash<type,cont>::hash(void) {}

template<class type,class cont>
hash<type,cont>::hash(int size) {
  HASH_NEW_EMPTY
  func=set<type>::map;
}

template<class type,class cont>
hash<type,cont>::hash(int size,uint (*func)(type)) {
  HASH_NEW_EMPTY
  this->func=func;
}

template<class type,class cont>
hash<type,cont>::~hash(void) {
  for (int c0=0;c0<table.numel;c0++)
    delete table(c0);  
}

//template<class type,class cont>
//const hash<type,cont>& hash<type,cont>::operator=(const hash<type,cont>& myHash) {
//  assert(false);
//  if (table.data==myHash.table.data)
//    return *this;
//  //// TODO if numel==myTensor.numel then don't delete data
//  //// TODO if ndims==myTensor.ndims then don't delete size
//  //if (table.data) {
//  //  for (int c0=0;c0<table.numel;c0++)
//  //    delete table(c0);
//  //}
//  //ndims=myTensor.ndims;
//  //size=new int[ndims];
//  //int c0;
//  //for (c0=0;c0<ndims;++c0)
//  //  size[c0]=myTensor.size[c0];
//  //TENSOR_NUMEL
//  //data=new type[numel];
//  //for (c0=0;c0<numel;++c0)
//  //  data[c0]=myTensor.data[c0];
//  return *this;
//}

template<class type,class cont>
int hash<type,cont>::get(const type& key,cont &data) {
  HASH_APPLY(data=buck.data;)
  return 0;
}

template<class type,class cont>
int hash<type,cont>::add(const type& key,const cont& data) {
  HASH_APPLY(;)
  buck.key=key;
  buck.data=data;
  table(adr)->add(buck);
  ++numel;
  return 0;
}

template<class type,class cont>
int hash<type,cont>::toggle(const type& key,const cont &data) {
  HASH_APPLY(table(adr)->remove(); --numel;)
  buck.key=key;
  buck.data=data;
  table(adr)->add(buck);
  ++numel;
  return 0;
}

template<class type,class cont>
int hash<type,cont>::remove(const type& key) {
  HASH_APPLY(table(adr)->remove(); --numel;)
  return 0;
}

template<class type,class cont>
void hash<type,cont>::empty(void) {
  for (int c0=0;c0<table.numel;c0++)
    table(c0)->empty();
  numel=0;
}

template<class type,class cont> 
tensor<cont> hash<type,cont>::toTensor(void) {
  tensor<cont> ret(1,numel);
  bucket<type,cont> buck;
  int count=0;
  for (int c0=0;c0<table.numel;c0++)
    while (table(c0)->token(buck))
      ret.data[count++]=buck.data;
  assert(count==numel);
  return ret;
}

template<class type,class cont>
cont hash<type,cont>::toTensor(int num) {
  cont ret(2,num,numel);
  bucket<type,cont> buck;
  int count=0;
  for (int c0=0;c0<table.numel;c0++)
    while (table(c0)->token(buck))
      for (int c1=0;c1<buck.data.numel;++c1)
        ret.data[count++]=buck.data.data[c1];
  assert(count==ret.numel);
  return ret;
}

template<class type,class cont> 
double hash<type,cont>::variance(void) {
  SET_VARIANCE
}

template<class type,class cont>
char* hash<type,cont>::toInfo(void) {
  sprintf(HASH_BUFFER,"hash<%i,%i>(%i/%i occ=%5.1f%% var=%5.1f)",sizeof(type),sizeof(cont),numel,table.numel,numel*100/(double)table.numel,variance());
  return HASH_BUFFER;
}

template<class type,class cont>
char* hash<type,cont>::toString(void) {
  return toTensor().toString();
}

#endif
