// code by jph
// for windows only

//#pragma comment(lib, "winmm.lib")

#ifndef TIME_INCLUDED
#define TIME_INCLUDED

#define TIME_INITIALIZE         if (static_frq==0) \
                                  QueryPerformanceFrequency((LARGE_INTEGER*)&static_frq);

static char TIME_BUFFER[64];

class time {
  public:
    time(void);
    time(__int64 raw);
    time(double s);
    time(const time& myTime);
    const time& operator=(const time& myTime);
    static time now(void);
    time operator+(const time& myTime);
    time operator-(const time& myTime);
    int operator<(const time& myTime);
    int operator<=(const time& myTime);
    const time& operator+=(const time& myTime);
    const time& operator-=(const time& myTime);
    const time& operator+=(const double& s);
    const time& operator-=(const double& s);
    double s(void);
    double ms(void);
    char* toInfo(void);
    char* toString(char* str);
    char* toString(void);
//----------------------------------------------------------------------
    __int64 raw;
    static __int64 static_frq;
};

time::time(void) {
  TIME_INITIALIZE
  raw=0;
}

time::time(__int64 raw) {
  TIME_INITIALIZE
  this->raw=raw;
}

time::time(double s) {
  TIME_INITIALIZE
  raw=s*static_frq;
}

time::time(const time& myTime) {
  TIME_INITIALIZE
  raw=myTime.raw;
}

const time& time::operator=(const time& myTime) {
  raw=myTime.raw;
  return *this;
}

time time::now(void) {
  __int64 tmp;
  QueryPerformanceCounter((LARGE_INTEGER*)&tmp);
  return time(tmp);
}

time time::operator+(const time& myTime) {
  return time(raw+myTime.raw);
}

time time::operator-(const time& myTime) {
  return time(raw-myTime.raw);
}

int time::operator<(const time& myTime) {
  return raw<myTime.raw;
}

int time::operator<=(const time& myTime) {
  return raw<=myTime.raw;
}

const time& time::operator+=(const time& myTime) {
  raw+=myTime.raw;
  return *this;
}

const time& time::operator-=(const time& myTime) {
  raw-=myTime.raw;
  return *this;
}

const time& time::operator+=(const double& s) {
  raw+=s*static_frq;
  return *this;
}

const time& time::operator-=(const double& s) {
  raw-=s*static_frq;
  return *this;
}

double time::s(void) {
  return (double)raw/(double)static_frq;
}

double time::ms(void) {
  return raw*1000/(double)static_frq;
}

char* time::toInfo(void) {
  TIME_INITIALIZE
  int* cst=(int*)&static_frq;  
  sprintf(TIME_BUFFER,"time(%08x%08x)",cst[1],cst[0]);
  return TIME_BUFFER;
}

char* time::toString(char* str) {
  int* val=(int*)&raw;
  sprintf(str,"%08x%08x",val[1],val[0]);
  return str;
}

char* time::toString(void) {
  return toString(TIME_BUFFER);
}

__int64 time::static_frq=0;

#endif
