// code by jph

#define _CRT_SECURE_NO_DEPRECATE  // no warnings when using std::c in vcpp compiler 14

#define NDEBUG
// #define OPENGL_FULLSCREEN "1680x1050:32"
// #define OPENGL_FULLSCREEN "800x600:32"

#include "../_util/_opengl.hpp"
#include "../_animated/_animated.hpp"

aniAvatar*            ava;

opengl_light* light_top;
aniFlow* flw;

meshgl myMesh;

int main(int argc,char** argv) {
  opengl_recording_numel=70;
  opengl_recording_frame=1;     // take shot every x frames
#ifdef NDEBUG                   // release mode
  //opengl_size.as(230,173);      // video format for most of my animations (confirmed 20091010)
  opengl_size.as(1024,768);
  //opengl_size.as(179,128);      // video format for most of my animations (confirmed 20091010)
  opengl_position.as(100,100);
#else                           // debug mode
  opengl_size.as(640,480);
  opengl_size.as(1024,768);
  opengl_position.as(1000,30);
  opengl_position.as(50,0);
#endif
  opengl_title=tensor<char>::string("Texture Advection for Fluid Flow");
  opengl_main(argc,argv);
  
  ava=new aniAvatar();
  ava->pos(2,3)=5;
  ava->fva=tensor<double>(1,4).as( 0.3, 0.3, 0.3, 0.0);
  ava->fot=tensor<double>(1,4).as( 0.3, 0.3, 0.3, 0.0);
  ava->status=ANI_HUMANIZED;
  
  light_top=new opengl_light();
  light_top->dif=opengl_color_gray90; // todo try without a=1.0
  //light_top->cut=30;
  //light_top->pos(0,0)= 0.0;
  //light_top->pos(1,0)= 0.0;
  //light_top->pos(2,0)=-1.0;  
  opengl_lighting=1;
  flw=new aniFlow("fir",4);
  //flw->col.as( 199.0/256, 164.0/256, 136.0/256, 1.0); // mar
  //flw->col.as( 30.0/256, 52.0/256, 76.0/256, 1.0); // pwn
  //flw->col.as( 206.0/256, 132.0/256, 107.0/256, 1.0); // sfs
  //flw->col.as( 77.0/256,160.0/256,174.0/256, 1.0); // wat
  flw->col.as(203.0/256, 77.0/256, 27.0/256, 1.0); // fir
  myMesh=meshgl::surface(tensor<float>("get/flow/field_m.arr"),flw->blu->extension());
  myMesh.color.as(135.0/256,108.0/256, 80.0/256, 1.0);
  
  ava->pos=glExp(tensor<double>::vector(4).as( 0.0, 0.0, MATH_PI_2, 0.0));
  ava->pos(0,3)=flw->blu->extension().data[0]*0.5;
  ava->pos(1,3)=flw->blu->extension().data[1]*0.5;
  ava->pos(2,3)=24.5;
  
  glutMainLoop();
  return 0;
}

void scene(void) {
  aniMated::dt=opengl_rate.s();
  aniMated* ani;
  ava->relax();
  ava->control();
  ava->motion();
  
  double fq=1,ra=5;  
  light_top->pos(0,3)=10;//+ra*cos(opengl_time.s()*fq);
  light_top->pos(1,3)=10;//+ra*sin(opengl_time.s()*fq);
  light_top->pos(2,3)=5;
  
  //aniPatch* ptc;  
  //tensor<double> pnt(1,2);
  //if (flw->list.token(ptc)) {
  //  ava->pos(0,3)=ptc->msh->arr(5,0);
  //  ava->pos(1,3)=ptc->msh->arr(6,0);
  //  ava->pos(2,3)=3;    
  //}  
  //flw->list.reset();
	flw->control();
  
  opengl_camera=glI(ava->pos);
  
}

void display(void) {
	//opengl_grid();
	flw->draw_std();
	myMesh.draw();
}

void shadow(tensor<double> pos) { }

void finish() { }

